<?php
namespace codeneric\phmm\elementor {
  require_once ($GLOBALS["HACKLIB_ROOT"]);
  class Extension {
    private static $_instance = null;
    public function __construct() {
      \add_action("plugins_loaded", array($this, "init"));
    }
    public function init() {
      if (\hacklib_cast_as_boolean(\did_action("elementor/loaded"))) {
        \add_action(
          "elementor/widgets/widgets_registered",
          array($this, "init_widgets")
        );
        \add_action(
          "elementor/elements/categories_registered",
          array($this, "add_elementor_widget_categories")
        );
      }
    }
    public function add_elementor_widget_categories($elements_manager) {
      $elements_manager->add_category(
        "codeneric-phmm",
        array(
          "title" => \__("Photography Management", "plugin-name"),
          "icon" => "fa fa-plug"
        )
      );
    }
    public function init_widgets() {
      require_once (dirname(__FILE__)."/elementor-widget-portal.php");
      \Elementor\Plugin::instance()
        ->widgets_manager
        ->register_widget_type(new \codeneric\phmm\elementor\widget\Portal());
    }
    public static function instance() {
      if (\hacklib_cast_as_boolean(\is_null(self::$_instance))) {
        self::$_instance = new self();
      }
      return self::$_instance;
    }
  }
}
